# coding: utf-8
import datetime
import autopath
from os.path import join
import subprocess
from copy import copy
from bson.objectid import ObjectId

from eoleaaf.util import db
from eoleaaf.parseaaf import main
from eoleaaf.parsedelta import main as main_delta
from eoleaaf.aaf import reset_db

def setup_function(module, ):
    reset_db()


data = join(autopath.HERE, 'data', '20170704')

data_complet = join(data, 'aaf-complet')
data_delta = join(data, 'aaf-delta', 'delete')


#def test_etablissement():
#    keys = set(etablissement.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
#    main(data_complet, reset_db=True, close=False)
#    main_delta(data_delta, close=False)
#    result = db.fetchall('etablissement')
#    list_etablissement = etablissements.keys()
#    for res in result:
#        idx = res['id']
#        if idx not in etablissements:
#            continue
#        print "etablissement", idx
#        list_etablissement.remove(idx)
#        assert keys == set(res.keys())
#        for key in etablissement.keys():
#            assert res[key] == etablissements[idx][key], u"la valeur correspondant à : {} est différente".format(key)
#    assert list_etablissement == []
#
#
#def test_subject():
#    keys = set(subject.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
#    main(data_complet, reset_db=True, close=False)
#    main_delta(data_delta, close=False)
#    list_subjects = subjects.keys()
#    result = db.fetchall('subject')
#    for res in result:
#        idx = res['id']
#        if idx not in subjects:
#            continue
#        print "subject", idx
#        assert keys == set(res.keys())
#        list_subjects.remove(idx)
#        for key in subject.keys():
#            assert res[key] == subjects[idx][key], u"la valeur correspondant à : {} est différente".format(key)
#    assert list_subjects == []
#
#
#

def test_prof():
    main(data_complet, False, close=False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'enseignant')
    for res in result:
        idx = res['id']
        if idx == '163':
            assert res[u'FieldActionType'] == u'DELTADELETE', u"l'utilisateur n'est pas marqué comme étant à supprimer"
            break
    else:
        raise Exception("L'utilisateur n'existe pas ")


def test_administratif():
    main(data_complet, False, close=False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'administratif')
    for res in result:
        idx = res['id']
        if idx == '34':
            assert res[u'FieldActionType'] == u'DELTADELETE', u"l'utilisateur n'est pas marqué comme étant à supprimer"
            break
    else:
        raise Exception("L'utilisateur n'existe pas ")


def test_responsable():
    main(data_complet, False, close=False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'responsable')
    for res in result:
        idx = res['id']
        if idx == '994845':
            assert res[u'FieldActionType'] == u'DELTADELETE', u"l'utilisateur n'est pas marqué comme étant à supprimer"
            break
    else:
        raise Exception("L'utilisateur n'existe pas ")


def test_eleves():
    main(data_complet, False, close=False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'eleve')
    for res in result:
        idx = res['id']
        if idx == '14357':
            assert res[u'FieldActionType'] == u'DELTADELETE', u"l'utilisateur n'est pas marqué comme étant à supprimer"
            break
    else:
        raise Exception("L'utilisateur n'existe pas ")
